#define git %%{nil}

Name:		mdadm
Version:	4.3
Release:	%mkrel 2
Summary:	A tool for managing Soft RAID under Linux
Group:		System/Kernel and hardware
License:	GPLv2+
URL:		https://www.kernel.org/pub/linux/utils/raid/mdadm/
Source0:	https://www.kernel.org/pub/linux/utils/raid/mdadm/mdadm-%{!?git:%version}%{?git:%git}.tar.xz
# fixes from uptream

# From Fedora
Source1:	mdadm-raid-check
# From Fedora, modified because our initscripts do not use incremental assembly
# modification can be reverted only _after_ initscripts has been fixed and a
# conflict for older inistcripts is added (bluca)
Source2:	mdadm.rules
Source3:	mdadm-raid-check-sysconfig
Source5:	mdadm-cron
Source4:	mdmonitor.service
Source8:	mdmonitor-takeover.service
Source9:	%{name}-tmpfiles.conf

# Build without -Werror.
Patch00:     disable-Werror.patch

Requires(pre):   filesystem >= 2.1.9-18
Requires(post):  systemd >= %{systemd_required_version}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1
# udev rule used to be in udev package
Conflicts:	udev < 145-2
BuildRequires:	groff
BuildRequires:	systemd-devel
BuildRequires:	pkgconfig(libudev)

%description
mdadm is a program that can be used to create, manage, and monitor
Linux MD (Software RAID) devices.

As such is provides similar functionality to the raidtools packages.
The particular differences to raidtools is that mdadm is a single
program, and it can perform (almost) all functions without a
configuration file (that a config file can be used to help with
some common tasks).

%prep
%autosetup -p1 %{?git:-n %name}

echo "PROGRAM %{_sbindir}/mdadm-syslog-events" >> mdadm.conf-example

%build
make SYSCONFDIR="%{_sysconfdir}" CXFLAGS="%{optflags} -Wno-error=format-truncation -Wno-error=restrict -Wno-format-overflow"

%install
%make_install MANDIR=%{_mandir} BINDIR=%{_sbindir} UDEVDIR=%{_prefix}/lib/udev
install -Dp -m 644 mdadm.conf-example %{buildroot}%{_sysconfdir}/mdadm.conf
install -Dp -m 755 %{SOURCE1} %{buildroot}%{_sbindir}/raid-check
install -Dp -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/raid-check
install -Dp -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/cron.d/raid-check
install -Dp misc/syslog-events %{buildroot}%{_sbindir}/mdadm-syslog-events

install -d -m 755 %{buildroot}%{_unitdir}
install -m 644 %{SOURCE4} %{buildroot}%{_unitdir}
install -m 644 %{SOURCE8} %{buildroot}%{_unitdir}
# (cg) Mask the sysvinit script
ln -s mdmonitor.service %{buildroot}%{_unitdir}/mdadm.service

install -D -p -m 644 %{SOURCE9} %{buildroot}%{_tmpfilesdir}/%{name}.conf

%preun
%_preun_service mdadm

%post
%_tmpfilescreate %{name}
ENABLE=
[ ! -f /var/lib/rpm-helper/systemd-migration/mdadm ] && ENABLE=yes
%_post_service mdadm
if [ "$ENABLE" = "yes" -a -L %{_sysconfdir}/systemd/system/multi-user.target.wants/mdmonitor.service -a ! -L %{_sysconfdir}/systemd/system/sysinit.target.wants/mdmonitor-takeover.service ]; then
  systemctl --quiet enable mdmonitor-takeover.service
fi

%files
%doc TODO ChangeLog README.initramfs ANNOUNCE*
%{_sbindir}/mdadm
%{_sbindir}/mdadm-syslog-events
%{_sbindir}/mdmon
%{_sbindir}/raid-check
%config(noreplace) %{_sysconfdir}/cron.d/raid-check
%config(noreplace,missingok) %{_sysconfdir}/mdadm.conf
%config(noreplace) %{_sysconfdir}/sysconfig/raid-check
%{_udevrulesdir}/01-md-raid-creating.rules
%{_udevrulesdir}/63-md-raid-arrays.rules
%{_udevrulesdir}/64-md-raid-assembly.rules
%{_udevrulesdir}/69-md-clustered-confirm-device.rules
%{_tmpfilesdir}/%{name}.conf
%{_unitdir}/mdadm.service
%{_unitdir}/mdmonitor.service
%{_unitdir}/mdmonitor-takeover.service
%dir %ghost %attr(0700, root, root) %{_rundir}/%{name}
%ghost %attr(0660, -, -) %{_rundir}/%{name}/mdadm.pid
%{_mandir}/man*/md*


%changelog
* Wed Jan 29 2025 mokraemer <mokraemer> 4.3-2.mga10
+ Revision: 2143342
- Added a message in case a drive cannot be checked (mga#33822)

* Tue Mar 05 2024 daviddavid <daviddavid> 4.3-1.mga10
+ Revision: 2047709
- new version: 4.3

* Thu Mar 24 2022 umeabot <umeabot> 4.2-6.mga9
+ Revision: 1825152
- Mageia 9 Mass Rebuild

* Tue Mar 08 2022 tv <tv> 4.2-5.mga9
+ Revision: 1789726
- BR systemd-devel
- 4.2

* Sun Feb 23 2020 daviddavid <daviddavid> 4.1-5.mga8
+ Revision: 1549664
- add fedora patch to build without -Werror
- make sure pid files and /run/mdadm folder are removed when uninstalled
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Fri Apr 05 2019 tmb <tmb> 4.1-4.mga7
+ Revision: 1386052
- add fixes from upstream
- mdmonitor: use /run instead of /var/run

* Sat Feb 02 2019 tmb <tmb> 4.1-2.mga7
+ Revision: 1362496
- add fixes from upstream

* Sun Jan 13 2019 tmb <tmb> 4.1-1.mga7
+ Revision: 1356100
- update to 4.1
  * drop merged patches

* Fri Sep 28 2018 umeabot <umeabot> 4.0-3.mga7
+ Revision: 1309402
- Mageia 7 Mass Rebuild

* Tue Sep 19 2017 tv <tv> 4.0-2.mga7
+ Revision: 1155738
- add build fixes from FC

* Tue Jan 10 2017 tmb <tmb> 4.0-1.mga6
+ Revision: 1080866
- update to 4.0 final

* Wed Jan 04 2017 tmb <tmb> 3.4-3.mga6
+ Revision: 1080090
- Don't assume VMD sysfs path ends with a disk entry

* Tue Jan 03 2017 tmb <tmb> 3.4-2.mga6
+ Revision: 1079914
- IMSM: Fix signed/unsigned comparisons
- add post 3.4 fixes from git
- update to 3.4

* Fri Feb 12 2016 umeabot <umeabot> 3.3.4-3.mga6
+ Revision: 956145
- Mageia 6 Mass Rebuild

* Fri Aug 21 2015 tmb <tmb> 3.3.4-2.mga6
+ Revision: 867937
- rebuild for new gcc

* Wed Aug 05 2015 tmb <tmb> 3.3.4-1.mga6
+ Revision: 861418
- update to 3.3.4

* Sat Aug 01 2015 tmb <tmb> 3.3.3-1.mga6
+ Revision: 860207
- update to 3.3.3

* Wed Oct 15 2014 umeabot <umeabot> 3.3.2-3.mga5
+ Revision: 745629
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.3.2-2.mga5
+ Revision: 682322
- Mageia 5 Mass Rebuild

* Sun Sep 07 2014 tmb <tmb> 3.3.2-1.mga5
+ Revision: 673161
- update to 3.3.2

* Mon Jul 07 2014 pterjan <pterjan> 3.3.1-1.mga5
+ Revision: 650342
- 3.3.1 (Bug-fix release with minor features such as systemd integration)

* Tue Oct 22 2013 umeabot <umeabot> 3.3-2.mga4
+ Revision: 541874
- Mageia 4 Mass Rebuild

* Sun Oct 13 2013 tmb <tmb> 3.3-1.mga4
+ Revision: 496491
- update to 3.3

* Sun Mar 24 2013 colin <colin> 3.2.6-3.mga3
+ Revision: 405136
- Use tmpfiles macros and add system version to requires (mga#9302)

* Sat Jan 12 2013 umeabot <umeabot> 3.2.6-2.mga3
+ Revision: 359881
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Oct 28 2012 tmb <tmb> 3.2.6-1.mga3
+ Revision: 310994
- update to 3.2.6
- drop P0 (merged)

* Tue Sep 11 2012 tv <tv> 3.2.5-6.mga3
+ Revision: 292453
- drop sysvinit support

* Sun Jul 29 2012 colin <colin> 3.2.5-5.mga3
+ Revision: 275767
- Add tmpfiles to fix startup issues for mdadm monitor
- Fix leakage of (expected) error code from %%post

* Fri Jul 27 2012 tv <tv> 3.2.5-4.1.mga3
+ Revision: 275055
- new version
- drop merged patches
- s/bash/sh/ in udev rule (instead of doing it when building installer stage2)
+ colin <colin>
- Allow migration to the systemd units included
- Do not load the environment file in systemd unit as there are no options used.

* Sat Apr 28 2012 tmb <tmb> 3.2.3-4.mga2
+ Revision: 233783
- Require rpm-helper >= 0.24.8-1 for systemd support

* Mon Apr 23 2012 tmb <tmb> 3.2.3-3.mga2
+ Revision: 233135
- super1: make aread/awrite always use an aligned buffer (P2)
- Use posix_memalign() for memory used to write bitmaps (P3)
- Print error message if failing to write super for 1.x metadata (P4)
- Bitmap_offset is a signed number (P5)
- fix: Monitor sometimes crashes (P6)

* Tue Mar 13 2012 guillomovitch <guillomovitch> 3.2.3-2.mga2
+ Revision: 223250
- spec cnealup
- systemd support

* Fri Dec 23 2011 tmb <tmb> 3.2.3-1.mga2
+ Revision: 187034
- update to 3.2.3
- rediff P1

* Wed Dec 07 2011 tmb <tmb> 3.2.2-2.mga2
+ Revision: 178079
- rebuild with gcc-4.6.2

* Fri Oct 28 2011 tmb <tmb> 3.2.2-1.mga2
+ Revision: 158918
- new version 3.2.2 (synced with mdv)
- resync raid check and mdadm init scripts with fedora (bluca, mdv)
  * Don't report mismatch counts on either raid1 or raid10
  * Check both active and idle arrays during raid check runs
  * Move the raid-check script from cron.weekly to /usr/sbin, add a
    crontab file to /etc/cron.d and mark it config(noreplace). This way
    users can select their own raid-check frequency and have it honored
    through upgrades.
  * Allow the raid-check script to set the process and io priority of the
    thread performing the check in order to preserve responsiveness of the
    machine during the check.
- split udev rules in two files like fedora, but honor dracut rd.md.imsm=0
  kernel command line and keep /dev/.in_sysinit hack
- add patch from fedora to fix build with -Wno-unused-parameter
- add two patches to fix build with -Wstrict-aliasing
- remove container-stop patch merged upstream

* Sat Apr 02 2011 tmb <tmb> 3.1.5-1.mga1
+ Revision: 79866
- update to 3.1.5
- drop P2 (merged)

* Wed Jan 12 2011 tmb <tmb> 3.1.4-3.mga1
+ Revision: 7583
- imported package mdadm

